
#ifdef __cplusplus
#ifndef __MINIMUM_H_
#define __MINIMUM_H_

extern "C++"
{

template<class TYPE, class T, const CLSID *pclsid, WCHAR wszModulename[] >
class CMinimumImpl : public CComObjectRootEx<CComMultiThreadModel>,
										 public CComCoClass< CMinimumImpl<TYPE,T,pclsid,wszModulename>, pclsid >,
										 public T
{

public:
	HRESULT __stdcall Min( TYPE a, TYPE b, TYPE *pMin )
	{
		*pMin = (a < b ? a : b );
		return S_OK;
	}
BEGIN_COM_MAP(CMinimumImpl)
	COM_INTERFACE_ENTRY_IID( __uuidof(T), T )
END_COM_MAP()

	static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
	{	
		OLECHAR wszCLSID[45];
		StringFromGUID2( *pclsid, wszCLSID, 45 );

		_ATL_REGMAP_ENTRY regMap[] = { { L"ObjName", wszModulename },
																		{ L"ObjCLSID", wszCLSID },
																		{ NULL, NULL } };
		
		return _Module.UpdateRegistryFromResourceD( IDR_POLYREG, bRegister, regMap );
	}

};


} //extern "c++"



#endif //__MINIMUM_H_
#endif //__cplusplus
