#include <windows.h>
#include <conio.h>

#include <atlbase.h>
#include <atlimpl.cpp>

#include "..\codeguru.h"
#include "..\codeguru_i.c"

void Test();

int main()
{
	CoInitialize( NULL );
		
		Test();

	CoUninitialize();

	return 0;
}


void Test()
{
	CComPtr<IMinimumInt> pMinInt;

	HRESULT hr = CoCreateInstance( CLSID_MinimumInt, 
																	NULL, 
																	CLSCTX_INPROC_SERVER, 
																	IID_IMinimumInt, 
																	(void**)&pMinInt );

	_ASSERT( SUCCEEDED( hr ) );

	int nA = 7;
	int nB = 9;
	int nMin = 0;

	hr = pMinInt->Min( nA, nB, &nMin );
	_ASSERT( SUCCEEDED( hr ) );

	printf( "The min value between %d and %d is %d\n", nA, nB, nMin );


	CComPtr<IMinimumDouble> pMinDouble;
	hr = CoCreateInstance( CLSID_MinimumDouble, 
													NULL, 
													CLSCTX_INPROC_SERVER, 
													IID_IMinimumDouble, 
													(void**)&pMinDouble );

	_ASSERT( SUCCEEDED( hr ) );

	double dA = 9.8;
	double dB = 7.2;
	double dMin = 0.0;
	
	hr = pMinDouble->Min( dA, dB, &dMin );
	_ASSERT( SUCCEEDED( hr ) );
	
	printf( "The min value between %e and %e is %e\n", dA, dB, dMin );
	
	getch();
}